"""
Do Not Edit this file. You may and are encouraged to look at it for reference.
"""

import sys
if sys.version_info.major != 3:
    print('You must use Python 3.x version to run this unit test')
    sys.exit(1)

import unittest

from test_CaloricBalance_init import TestCaloricBalanceInit
from test_CaloricBalance_getBMR import TestCaloricBalanceGetBMR
from test_CaloricBalance_getBalance import TestCaloricBalanceGetBalance
from test_CaloricBalance_recordActivity import TestCaloricBalanceRecordActivity
from test_CaloricBalance_eatFood import TestCaloricBalanceEatFood

class TestCaloricBalanceAll(unittest.TestCase):
    def test001_fullRun(self):
        from caloric_balance import CaloricBalance
        cb = CaloricBalance('f', 23.0, 65.0, 130.0)

        balance = cb.getBalance()
        expected = -1417.9
        self.assertAlmostEqual(balance, expected, 2,
                               'Your result (%s) is not close enough to (%s)' % (balance, expected))

        cb.eatFood(400)
        balance = cb.getBalance()
        expected = -1017.9
        self.assertAlmostEqual(balance, expected, 2,
                               'Your result (%s) is not close enough to (%s)' % (balance, expected))

        cb.eatFood(906)
        balance = cb.getBalance()
        expected = -111.9
        self.assertAlmostEqual(balance, expected, 2,
                               'Your result (%s) is not close enough to (%s)' % (balance, expected))

        cb.recordActivity(0.074, 30)
        balance = cb.getBalance()
        expected = -400.5
        self.assertAlmostEqual(balance, expected, 2,
                               'Your result (%s) is not close enough to (%s)' % (balance, expected))

        cb.recordActivity(0.087, 15)
        balance = cb.getBalance()
        expected = -570.15
        self.assertAlmostEqual(balance, expected, 2,
                               'Your result (%s) is not close enough to (%s)' % (balance, expected))

        cb.eatFood(450)
        balance = cb.getBalance()
        expected = -120.15
        self.assertAlmostEqual(balance, expected, 2,
                               'Your result (%s) is not close enough to (%s)' % (balance, expected))


    def test002_fullRun(self):
        from caloric_balance import CaloricBalance
        cb = CaloricBalance('m', 26.0, 70.5, 185.0)

        balance = cb.getBalance()
        expected = -1937.1
        self.assertAlmostEqual(balance, expected, 2,
                               'Your result (%s) is not close enough to (%s)' % (balance, expected))

        cb.eatFood(400)
        balance = cb.getBalance()
        expected = -1537.1
        self.assertAlmostEqual(balance, expected, 2,
                               'Your result (%s) is not close enough to (%s)' % (balance, expected))

        cb.eatFood(906)
        balance = cb.getBalance()
        expected = -631.1
        self.assertAlmostEqual(balance, expected, 2,
                               'Your result (%s) is not close enough to (%s)' % (balance, expected))

        cb.recordActivity(0.074, 30)
        balance = cb.getBalance()
        expected = -1041.8
        self.assertAlmostEqual(balance, expected, 2,
                               'Your result (%s) is not close enough to (%s)' % (balance, expected))

        cb.recordActivity(0.087, 15)
        balance = cb.getBalance()
        expected = -1283.23
        self.assertAlmostEqual(balance, expected, 2,
                               'Your result (%s) is not close enough to (%s)' % (balance, expected))

        cb.eatFood(450)
        balance = cb.getBalance()
        expected = -833.23
        self.assertAlmostEqual(balance, expected, 2,
                               'Your result (%s) is not close enough to (%s)' % (balance, expected))


if __name__ == '__main__':
    unittest.main()
