"""
Do Not Edit this file. You may and are encouraged to look at it for reference.
Do Not Move on to the next function until its tests report 'ok' or your code
may not work as expected.
"""

import sys
if sys.version_info.major != 3:
    print('You must use Python 3.x version to run this unit test')
    sys.exit(1)

import unittest

# This is another test designed for the unittest discovery to find and fail on.
# it will not be used if the file is ran directly.
class TestAllFail(unittest.TestCase):
    def test_fail(self):
        self.fail('You should run the test_all.py file directly, Do not use the "Run Unittests in test_all.py" option from your IDE')

if __name__ == '__main__':
    from test_CaloricBalance_init import TestCaloricBalanceInit
    from test_CaloricBalance_getBMR import TestCaloricBalanceGetBMR
    from test_CaloricBalance_getBalance import TestCaloricBalanceGetBalance
    from test_CaloricBalance_recordActivity import TestCaloricBalanceRecordActivity
    from test_CaloricBalance_eatFood import TestCaloricBalanceEatFood
    from test_CaloricBalance_all import TestCaloricBalanceAll
    from test_main_formatMenu import TestFormatMenu
    from test_main_formatMenuPrompt import TestFormatMenuPrompt
    from test_main_formatActivityMenu import TestFormatActivityMenu
    from test_main_getUserString import TestGetUserString
    from test_main_getUserFloat import TestGetUserFloat
    from test_main_createCaloricBalance import TestCreateCaloricBalance
    from test_main_recordActivityAction import TestRecordActivityAction
    from test_main_eatFoodAction import TestEatFoodAction
    from test_main_quitAction import TestQuitAction
    from test_main_applyAction import TestApplyAction

    testCases = [
        TestCaloricBalanceInit,
        TestCaloricBalanceGetBMR,
        TestCaloricBalanceGetBalance,
        TestCaloricBalanceRecordActivity,
        TestCaloricBalanceEatFood,
        TestCaloricBalanceAll,
        TestFormatMenu,
        TestFormatMenuPrompt,
        TestFormatActivityMenu,
        TestGetUserString,
        TestGetUserFloat,
        TestCreateCaloricBalance,
        TestRecordActivityAction,
        TestEatFoodAction,
        TestQuitAction,
        TestApplyAction
    ]

    allTests = []
    for testCase in testCases:
        allTests.append(unittest.TestLoader().loadTestsFromTestCase(testCase))

    unittest.TextTestRunner().run(unittest.TestSuite(allTests))
else:
    print('THE TEST SUITE WAS NOT EXECUTED.')
    print('You need to run this file directly; not in "unittest" mode.')
    print('This file can not be imported as a module.')
    print('If you see this message it does not mean your code does not work,')
    print('but rather this file was run incorrectly.')
